<?php
/* vim:set expandtab tabstop=4 shiftwidth=4 softtabstop=4 foldmethod=marker syntax=php: */
// Whoops! Not PEAR compliant
require_once('firephp.php');
/**
 * Store the instance of Fire PHP.
 *
 * @global firephp
 * @alias $_FIREPHP
 */
$GLOBALS['_FIREPHP'] = null;
// {{{ firephp_tools
/**
 * A library for handling FirePHP.
 *
 * Technically I should have thought about using a singleton here, but
 * I need to maintain PHP4 compatibility and I'm lazy.
 *
 * Changelist:
 * - 0.2 PHP 5 should auto create the correct header (untested).
 *
 * @version 0.2
 * @author terry chay <tychay@php.net>
 * @copyright Terry Chay c. 2006
 * @license BSD
 */
class firephp_tools
{
    // {{{ + start()
    /**
     * Start up the FirePHP on the current buffer.
     *
     * Normally you must call this sort of thing before writing any headers.
     * This is the suck so I dodge it using an output buffer. This may
     * interact unkindly with other output buffers (gzip, deflate anyone?).
     * Such as it is.
     */
    function start()
    {
        global $_FIREPHP;
        $_FIREPHP = new firephp();
        //generate a requestID?
        $_FIREPHP->generateUniqId();
        // only launch if firephp enabled on client side
        if ($_FIREPHP->doesBrowserAccept()) {
            $_FIREPHP->enableMultipartData();
        }
        ob_start(array('firephp_tools','end'));
        $_FIREPHP->stampTime('processing');
    }
    // }}}
    // {{{ + dump($variable)
    /**
     * Dump a variable to firephp return window
     *
     * Using var_dump() to pretty print with Xdebug.
     * @since 0.2
     */
    function dump($variable,$title="")
    {
        if ($title) { firephp_tools::appendContent(sprintf('<h3>%s</h3>',$title)); }
        ob_start();
        var_dump($variable);
        firephp_tools::appendContent(ob_get_clean());
    }
    // }}}
    // {{{ + appendContent($content)
    /**
     * Add stuff to the FirePHP return
     */
    function appendContent($content)
    {
        global $_FIREPHP;
        $_FIREPHP->firebugContent .= $content;
    }
    // }}}
    // {{{ + end($content)
    /**
     * Dump FirePHP content
     */
    function end($content)
    {
        global $_FIREPHP;
        // find the content type if set {{{
        $content_type = 'text/html'; //default
        if (function_exists('headers_list')) {
            $headers = headers_list();
            foreach ($headers as $header_text) {
                $header_text = strtolower($header_text);
                if (strcmp(substr($header_text,0,13),'content-type:')===0) {
                    $content_type = substr($header_text,15);
                    break;
                }
            }
        }
        // }}}
        firephp_tools::appendContent(sprintf('<h3>PHP execute time</h3>%.4fs</h3>',$_FIREPHP->stopTimer('processing')));
        return $_FIREPHP->getContent($content,$content_type);
    }
    // }}}
}
// }}}
?>
